%this is the system of the FOC for the private info problem

function system = system(x)
global sigma gamma z_H z_L A u up v vp W W_b Pi

c_L = x(1);
c_H = x(2);
y_L = x(3); 
y_H = x(4); 
b_L = x(5); 
b_H = x(6); 
lambda = x(7); 
mu = x(8);

system = zeros(8,1);

system(1,1) = up(c_H)*(1+mu) - lambda;
system(2,1) = up(c_L)*(1-mu) - lambda;
system(3,1) = vp(y_H/z_H)/z_H*(1+mu) - lambda;
system(4,1) = vp(y_L/z_L)/z_L - mu*vp(y_L/z_H)/z_H - lambda;
system(5,1) = W_b(b_H, z_H, Pi)*(1+mu) - lambda;
system(6,1) = W_b(b_L, z_L, Pi) - mu*W_b(b_L, z_H, Pi) - lambda;
system(7,1) = c_H + c_L + b_H + b_L - y_H - y_L - A;
system(8,1) = u(c_H) - v(y_H/z_H) + W(b_H, z_H, Pi) - u(c_L) + v(y_L/z_H) - W(b_L, z_H, Pi);