%this is the system of the FOC for the aggregate uncertainty case, 2 kids,
%N states, PRIVATE info with parents

%it assumes beta = 1 and also initial distribution uniform over types

%gives the same for 2 states as some previous code

%set alpha = 0 don't want to worry about non-negativity on b

function systemnew = systemnew(x)
global N Z1 A u up v vp T W W_b eta zP R beta P Z2 phi mu_yP N2 NA %S1 S2 alpha
z = Z1;

%alpha controls the penalty on negative bequests, large alpha will imply
%non-negative bequests, practically alpha 10^-3 is enough to have a minm
%bequest larger than -1 dollar
alpha = 0*10^-3;
expo = 2;
%kappab controls the penalty on non-equal bequests
kappab =0*10^3;
expob = 2;
%kappag controls the penalty on non-equal gifts
kappag = 0*10^3;
expog = 2;

c1       = reshape(x(1:N^2), N, N);
y1       = reshape(x(N^2+1:2*N^2), N, N);
b1       = reshape(x(2*N^2+1:3*N^2), N, N);

%define c2 by symmetry
c2 = c1';
y2 = y1';
b2 = b1';
%note i in columns, j in lines (state - (z_i, z_j) and I determine i's allocations)

lvec   = x(3*N^2+1:3*N^2+N*(N+1)/2);
%this is the vector of lambdas, in matrix form we set elements: a11; a12,
%a22; a13, a23, a33 etc ...

%note that lambdas are multiplied by pi_j|pi_P

cP = x(3*N^2+N*(N+1)/2+N-1 + 1: 3*N^2+N*(N+1)/2+N-1 + N*(N+1)/2);
yP = x(3*N^2+N*(N+1)/2+N-1 + N*(N+1)/2 + 1: 3*N^2+N*(N+1)/2+N-1 + N*(N+1));

%make it to a diagonal matrix
lambda = zeros(N,N);

%this here is for feasibility only, vectors of length N*(N+1)/2
c1f = zeros(N*(N+1)/2,1);
y1f = zeros(N*(N+1)/2,1);
b1f = zeros(N*(N+1)/2,1);
c2f = zeros(N*(N+1)/2,1);
y2f = zeros(N*(N+1)/2,1);
b2f = zeros(N*(N+1)/2,1);


for i = 1:N
    lambda(i, 1:i) = lvec(i*(i-1)/2+1:i*(i+1)/2)';
    lambda(1:i, i) = lvec(i*(i-1)/2+1:i*(i+1)/2);
   
    c1f(i*(i-1)/2+1:i*(i-1)/2+i) = c1(1:i, i);
    y1f(i*(i-1)/2+1:i*(i-1)/2+i) = y1(1:i, i);
    b1f(i*(i-1)/2+1:i*(i-1)/2+i) = b1(1:i, i);
    c2f(i*(i-1)/2+1:i*(i-1)/2+i) = c2(1:i, i);
    y2f(i*(i-1)/2+1:i*(i-1)/2+i) = y2(1:i, i);
    b2f(i*(i-1)/2+1:i*(i-1)/2+i) = b2(1:i, i);
    
    P1red(i*(i-1)/2+1:i*(i+1)/2) = P(i)*ones(i,1);
    P2red(i*(i-1)/2+1:i*(i+1)/2) = P(1:i);
end
%reduced vector = [pi_1, pi_2, pi_2, pi_3, pi_3, pi_3 ...]'
P1red = P1red'; 
%[P(1); P(2); P(2); P(3); P(3); P(3)]
P2red = P2red';
%[P(1); P(1); P(2); P(1); P(2); P(3)] 
%it doesn't really matter which way this is done since P1red and P2red are
%muliplied in the FOC anyways

%convert back into vectors it seems more useful
lambda = reshape(lambda, N^2, 1);

%cP = reshape(cP, N^2, 1);
%yP = reshape(yP, N^2, 1);


c1 = x(1:N^2);
y1 = x(N^2+1:2*N^2);
b1 = x(2*N^2+1:3*N^2);



c2 = reshape(c2, N^2, 1);
y2 = reshape(y2, N^2, 1);
b2 = reshape(b2, N^2, 1);
g1 = c1 - y1;
g2 = c2 - y2;
%the above seems fine

%compute the true bequests now for the non-negativity constraint
%check whether child's savings are taken as given by parents
%tb1 = b1*exp(mu_yP) - S1;
%tb2 = b2*exp(mu_yP) - S2;
%compute the true bequests now for the non-negativity constraint
%s1 = exp(- 4.6971 + 1.1489*log(y1*exp(mu_yP)));
%s2 = exp(- 4.6971 + 1.1489*log(y2*exp(mu_yP)));

s1 = exp(-9.8624 + 1.5460*log(y1*exp(mu_yP)));
s2 = exp(-9.8624 + 1.5460*log(y2*exp(mu_yP)));
tb1 = b1*exp(mu_yP) - s1;
tb2 = b2*exp(mu_yP) - s2;
tg1 = g1*exp(mu_yP) + s1/R;
tg2 = g2*exp(mu_yP) + s2/R;

%local downward only - first \mu_1=0 because the lowest type cannot lie,
%last \mu_{N+1}=0 because nobody can pretend to be the highest type,
%there is no N+1 type
mu = [0; x(3*N^2+N*(N+1)/2+1:3*N^2+N*(N+1)/2+N-1); 0]; %correct

%expand mu, each shows up N times in this vector
muvec = kron(mu,ones(N,1)); %correct
P1vec = kron(P,ones(N,1));
P2vec = kron(ones(N,1),P);
%similarly expand probabilities of 1st kid

foc = ones(3*N^2+N*(N+1)/2+N-1 + N*(N+1),1);

%zvec is the expanded vector of states that has each state N-times,
%N+1 type gets skill .001 but his mu will be 0, so it doesn't matter (checked)
zvec = [kron(z,ones(N,1)); 0.0001*ones(N,1)];

%FOC's - multiply everything by P2vec rather than divide - hard to deal
%with P = 0 or close to zero which happens for large persistence off
%diagonal

%trying to save some time on W, but here compute the same w twice!

%W   = @(b, t) sum([kron(t, ones(N,1));kron(t, ones(N,1))].*wnew(b),2);

cont0 = wnew(b1);
%cont0 = wdyn(b1);
cont1 = sum([kron(T, ones(N,1));kron(T, ones(N,1))].*cont0,2);
%cont1 = W(b1, T)
 Wtrue = cont1(N+1:N^2);
 Wtrueprime = cont1(N^2+1: 2*N^2);
 
 cont2 = sum([kron([T(2:N, :);zeros(1,N)], ones(N,1));kron([T(2:N, :);zeros(1,N)], ones(N,1))].*cont0,2);
%cont2 = W(b1, [T(2:N, :);zeros(1,N)])
 Wlie = cont2(1:N^2-N);
 Wlieprime = cont2(N^2+1:2*N^2);



foc(1 : N^2)          =    up(c1).*(eta*P1vec+muvec(1:N^2) - muvec(N+1:N^2+N)) - lambda./P2vec + sign(tg2-tg1).*kappag.*abs((tg1-tg2)).^expog./P2vec;
foc(N^2+1 : 2*N^2)    =    phi*vp(y1./zvec(1:N^2))./zvec(1:N^2).*(eta*P1vec+muvec(1:N^2)) + ...
    - phi*vp(y1./zvec(N+1:N^2+N))./zvec(N+1:N^2+N).*muvec(N+1:N^2+N) - lambda./P2vec + sign(tg2-tg1).*kappag.*abs((tg1-tg2)).^expog./P2vec;
foc(2*N^2+1 : 3*N^2)  =   beta* Wtrueprime.*(eta*P1vec+muvec(1:N^2)) - beta*Wlieprime.*muvec(N+1:N^2+N) - lambda/R./P2vec + ...
    + sign(tb2-tb1).*kappab.*abs((tb1-tb2)).^expob./P2vec + alpha*(abs(tb1)).^(expo).*(tb1<0)./P2vec;

%feasibilities - use symmetry
foc(3*N^2+1:3*N^2+N*(N+1)/2)    = c1f + c2f + cP + b1f/R + b2f/R - y1f - y2f - yP - A;


%IC's
foc(3*N^2+N*(N+1)/2+1:3*N^2+N*(N+1)/2+N-1) = (sum(reshape(P2vec(N+1:N^2).*(u(c1(N+1:N^2)) - phi*v(y1(N+1:N^2)./zvec(N+1:N^2)) + beta*Wtrue +...
                     - u(c1(1:N^2-N)) + phi*v(y1(1:N^2-N)./zvec(N+1:N^2)) - beta*Wlie), N, N-1)))';

    
%foc's for the parents' allocations
foc(3*N^2+N*(N+1)/2+N-1+1:3*N^2+N*(N+1)/2+N-1+N*(N+1)/2) = P1red.*up(cP) - lvec./P2red;
foc(3*N^2+N*(N+1)/2+N-1+N*(N+1)/2+1:3*N^2+N*(N+1)/2+N-1+N*(N+1)) = phi*P1red.*vp(yP/zP)/zP - lvec./P2red;
systemnew = foc;
%save systemnew systemnew

%display 'the foc are'                 
%foc;
%sum(abs(foc));                                     
