*Please, use Stata 13.

clear all
set more off
cd "c:\Users\cslavik\Research\AAA Optimal Contracting\Bequests\our paper\RED submsission\Codes and Data\PSID Data and Codes\"

*************************************************
* do some data reconstruction
*************************************************
import excel "cpi_minwage.xlsx", sheet("Sheet1") firstrow clear
drop yeartrue

merge 1:m year using Data_reshaped.dta
drop if _merge == 1

*************************************************
* 1. clean the data, e.g convert catogory variables to  numeric values
*************************************************
gen Head = 1 if Relation == 1 & year >= 1968 & year <= 1982 & SequenceNum < 60
replace Head = 1 if Relation == 10 & year >= 1983 & SequenceNum < 60
replace Head = 1 if Relation == 1 & year == 1968
label variable Head "Head of current HH"

replace Head = 2 if Relation == 2 & year >= 1968 & year <= 1982
replace Head = 2 if Relation >= 20 & Relation < 30 & year >= 1983
replace Head = 2 if Relation == 2 & year == 1968


* replace WifeTotalWageExcludeBusi = . if WifeTotalWageExcludeBusi == 9999999 & (year == 1994 | year == 1995)
drop if WifeTotalWageExcludeBusi == 9999999 & (year == 1994 | year == 1995)
* replace WifeBusiness = . if WifeBusiness == 999999 & (year == 1994 | year == 1995 | year == 1997)
drop if WifeBusiness == 999999 & (year == 1994 | year == 1995 | year == 1997)

replace WifeTotalWageExcludeBusi = 0 if WifeTotalWageExcludeBusi == .
replace WifeBusiness = 0 if WifeBusiness == .
replace WifeTotalWage = WifeTotalWageExcludeBusi + WifeBusiness if WifeTotalWage == .
* replace transfers if we know it is inheritance, otherwise inheritance is regarded transfer
* before 1982, the question doesn't ask exact amount
* I replace the value using the middle point of each range

replace Transfer = 250 if Transfer == 1 & year <= 1982
replace Transfer = 750 if Transfer == 2 & year <= 1982
replace Transfer = 1500 if Transfer == 3 & year <= 1982
replace Transfer = 2500 if Transfer == 4 & year <= 1982
replace Transfer = 4000 if Transfer == 5 & year <= 1982
replace Transfer = (5000+7499)/2 if Transfer == 6 & year <= 1982
replace Transfer = (7500+9999)/2 if Transfer == 7 & year <= 1982
replace Transfer = 10000 if Transfer == 8 & year <= 1982
replace Transfer = . if Transfer == 9 & year <= 1982
replace Transfer = 0 if Transfer == 10 & year <= 1982


replace Transfer = . if Transfer == 99999 & year == 1983
* top coding is changed
replace Transfer = . if Transfer == 999999 & (year >= 1984 & year <= 1993) 

******************************************************************************************
* this is to double check, they exclude top coding when calculate the mean
replace Transfer = . if Transfer == 999998 & (year >= 1984 & year <= 1993)
replace Transfer = . if Transfer == 999998 & (year >= 1994 & year <= 1996)
replace Transfer = . if Transfer == 999999 & (year >= 1994 & year <= 1996)
* top coding is changed
replace Transfer = . if Transfer == 9999998 & (year >= 1997 & year <= 2013)
replace Transfer = . if Transfer == 9999999 & (year >= 1997 & year <= 2013)

replace Inheritance = .  if Inheritance == 999999 & (year >= 1988 & year <= 1993)
replace Inheritance = .  if Inheritance == 999998 & (year >= 1994 & year <= 1996)
replace Inheritance = .  if Inheritance == 999999 & (year >= 1994 & year <= 1996)
replace Inheritance = .  if Inheritance == 9999998 & (year >= 1997 & year <= 2013)
replace Inheritance = .  if Inheritance == 9999999 & (year >= 1997 & year <= 2013)

* inheritance are recorded with exact values
replace Transfer = Inheritance if Inheritance ~= .
replace ID = IW if year == 1968

gen HHWage = HeadTotalWage + WifeTotalWage
replace AgeWife = . if AgeWife == 0
gen HeadAgeBequest = AgeHead if Transfer > 0 & Transfer ~= .
gen WifeAgeBequest = AgeWife if Transfer > 0 & Transfer ~= .
order ID year

* some wifes have age 0, it means no wife in HH
replace AgeWife =. if AgeWife == 0 
sort ID year

* relative helps to head was reported in catogery variable before 1975
* I take the mean value of the range for each catogery, e.g. $500 - 999, I take $750
* for the helps from relative/nonrelatives, there are two data source, one is from interview, the other one is reported
* I replace the record if the reported amount is larger
* for some years there is only reported value
replace RelativeHead = 250 if RelativeHead == 1 & year <= 1975
replace RelativeHead = 750 if RelativeHead == 2 & year <= 1975
replace RelativeHead = 1500 if RelativeHead == 3 & year <= 1975
replace RelativeHead = 2500 if RelativeHead == 4 & year <= 1975
replace RelativeHead = 4000 if RelativeHead == 5 & year <= 1975
replace RelativeHead = (5000+7499)/2 if RelativeHead == 6 & year <= 1975
replace RelativeHead = (7500+9999)/2 if RelativeHead == 7 & year <= 1975
replace RelativeHead = 10000 if RelativeHead == 8 & year <= 1975
replace RelativeHead = . if RelativeHead == 9 & year <= 1975

* relatives report
replace RelativeHeadReport = . if RelativeHeadReport == 99999 & year == 1993
replace RelativeHeadReport = . if RelativeHeadReport == 99998 | RelativeHeadReport == 99999 & year >= 1994 & year <= 2001
replace RelativeHeadReport = . if RelativeHeadReport == 999998 | RelativeHeadReport == 999999 & year >= 2003 

* adjust time unit head
replace RelativeHeadReport = RelativeHeadReport*52 if RelativeHeadReportUnit == 1 & (year >= 1994 & year <= 1995)
replace RelativeHeadReport = RelativeHeadReport*26 if RelativeHeadReportUnit == 2 & (year >= 1994 & year <= 1995)
replace RelativeHeadReport = RelativeHeadReport*12 if RelativeHeadReportUnit == 3 & (year >= 1994 & year <= 1995)

replace RelativeHeadReport = RelativeHeadReport*52 if RelativeHeadReportUnit == 3 & (year >= 1996 & year <= 2013 | year == 1993)
replace RelativeHeadReport = RelativeHeadReport*26 if RelativeHeadReportUnit == 4 & (year >= 1996 & year <= 2013 | year == 1993)
replace RelativeHeadReport = RelativeHeadReport*1  if RelativeHeadReportUnit == 5 & (year >= 1996 & year <= 2013 | year == 1993)

* adjust time unit wife
replace RelativeWifeReport = . if RelativeWifeReport == 99999 & year == 1993
replace RelativeWifeReport = . if RelativeWifeReport == 99998 | RelativeWifeReport == 99999 & year >= 1994 & year <= 2001
replace RelativeWifeReport = . if RelativeWifeReport == 999998 | RelativeWifeReport == 999999 & year >= 2003 

replace RelativeWifeReport = RelativeWifeReport*52 if RelativeWifeReportUnit == 1 & (year >= 1994 & year <= 1995)
replace RelativeWifeReport = RelativeWifeReport*26 if RelativeWifeReportUnit == 2 & (year >= 1994 & year <= 1995)
replace RelativeWifeReport = RelativeWifeReport*12 if RelativeWifeReportUnit == 3 & (year >= 1994 & year <= 1995)

replace RelativeWifeReport = RelativeWifeReport*52 if RelativeWifeReportUnit == 3 & (year >= 1996 & year <= 2013 | year == 1993)
replace RelativeWifeReport = RelativeWifeReport*26 if RelativeWifeReportUnit == 4 & (year >= 1996 & year <= 2013 | year == 1993)
replace RelativeWifeReport = RelativeWifeReport*1  if RelativeWifeReportUnit == 5 & (year >= 1996 & year <= 2013 | year == 1993)

* non relatives report
replace NonrelativeHeadReport = . if NonrelativeHeadReport == 99999 & year == 1993
replace NonrelativeHeadReport = . if NonrelativeHeadReport == 99998 | NonrelativeHeadReport == 99999 & year >= 1994 & year <= 2001
replace NonrelativeHeadReport = . if NonrelativeHeadReport == 999998 | NonrelativeHeadReport == 999999 & year >= 2003 

* adjust time unit head

replace NonrelativeHeadReport = NonrelativeHeadReport*52 if NonrelativeHeadReportUnit == 1 & (year >= 1994 & year <= 1995)
replace NonrelativeHeadReport = NonrelativeHeadReport*26 if NonrelativeHeadReportUnit == 2 & (year >= 1994 & year <= 1995)
replace NonrelativeHeadReport = NonrelativeHeadReport*12 if NonrelativeHeadReportUnit == 3 & (year >= 1994 & year <= 1995)

replace NonrelativeHeadReport = NonrelativeHeadReport*52 if NonrelativeHeadReportUnit == 3 & (year >= 1996 & year <= 2013 | year == 1993)
replace NonrelativeHeadReport = NonrelativeHeadReport*26 if NonrelativeHeadReportUnit == 4 & (year >= 1996 & year <= 2013 | year == 1993)
replace NonrelativeHeadReport = NonrelativeHeadReport*1  if NonrelativeHeadReportUnit == 5 & (year >= 1996 & year <= 2013 | year == 1993)

replace NonrelativeWifeReport = . if NonrelativeWifeReport == 99999 & year == 1993
replace NonrelativeWifeReport = . if NonrelativeWifeReport == 99998 | NonrelativeWifeReport == 99999 & year >= 1994 & year <= 2001
replace NonrelativeWifeReport = . if NonrelativeWifeReport == 999998 | NonrelativeWifeReport == 999999 & year >= 2003 

* adjust time unit wife

replace NonrelativeWifeReport = NonrelativeWifeReport*52 if NonrelativeWifeReportUnit == 1 & (year >= 1994 & year <= 1995)
replace NonrelativeWifeReport = NonrelativeWifeReport*26 if NonrelativeWifeReportUnit == 2 & (year >= 1994 & year <= 1995)
replace NonrelativeWifeReport = NonrelativeWifeReport*12 if NonrelativeWifeReportUnit == 3 & (year >= 1994 & year <= 1995)

replace NonrelativeWifeReport = NonrelativeWifeReport*52 if NonrelativeWifeReportUnit == 3 & (year >= 1996 & year <= 2013 | year == 1993)
replace NonrelativeWifeReport = NonrelativeWifeReport*26 if NonrelativeWifeReportUnit == 4 & (year >= 1996 & year <= 2013 | year == 1993)
replace NonrelativeWifeReport = NonrelativeWifeReport*1  if NonrelativeWifeReportUnit == 5 & (year >= 1996 & year <= 2013 | year == 1993)

replace RelativeHead = RelativeHeadReport if ( (RelativeHeadReport > RelativeHead) | (RelativeHead == .) ) & RelativeHeadReport ~= .
replace RelativeWife = RelativeWifeReport if ( (RelativeWifeReport > RelativeWife) | (RelativeWife == .) ) & RelativeWifeReport ~= .

replace NonrelativeHead = NonrelativeHeadReport if ((NonrelativeHeadReport > NonrelativeHead) | (NonrelativeHead == .)) & NonrelativeHeadReport ~= .
replace NonrelativeWife = NonrelativeWifeReport if ((NonrelativeWifeReport > NonrelativeWife) | (NonrelativeWife == .)) & NonrelativeWifeReport ~= .

* working hours
replace HeadHours = . if HeadHours == 9999 & (year >= 1994 & year <= 1995)
replace HeadHours = . if HeadHours == 7800 & (year >= 1996)

replace WifeHours = . if (WifeHours == 6730 | WifeHours == 9999 ) & year == 1994
replace WifeHours = . if (WifeHours == 9999 ) & year == 1995

* add Head business income back
replace HeadBusi = . if HeadBusi == 999999 & (year == 1994 | year==1995 | year==1997)
replace HeadBusi = . if HeadBusi == 999999 & (year == 1994 | year==1995 | year==1997)
gen HeadIncludeBusi = HeadTotalWage + HeadBusi if year >= 1994

* replace the NA for head hourly wage
replace HeadWageHour = . if HeadWageHour > 99.98 & (year == 1968 | year == 1971 | year==1975 )
replace HeadWageHour = . if HeadWageHour >= 9998 & year>=1994 & year<=2001

replace WifeWageHour = . if WifeWageHour > 99.98 & (year == 1968 | year==1975 | year==1976 | year==1977 | year==1981 )
replace WifeWageHour = . if WifeWageHour>=9998 & year>=1994 & year<=2001

gen HeadWage_gen = HeadTotalWage/HeadHours
gen WifeWage_gen = WifeTotalWage/WifeHours

* Head Wage, replace latinos or immigrants sample with missing
replace HeadWage = 250 if HeadWage == 1 & (year == 1968 | year == 1969)
replace HeadWage = 750 if HeadWage == 2 & (year == 1968 | year == 1969)
replace HeadWage = 1500 if HeadWage == 3 & (year == 1968 | year == 1969)
replace HeadWage = 2500 if HeadWage == 4 & (year == 1968 | year == 1969)
replace HeadWage = 4000 if HeadWage == 5 & (year == 1968 | year == 1969)
replace HeadWage = (5000+7499)/2 if HeadWage == 6 & (year == 1968 | year == 1969)
replace HeadWage = (7500+9999)/2 if HeadWage == 7 & (year == 1968 | year == 1969)
replace HeadWage = 10000 if HeadWage == 8 & (year == 1968 | year == 1969)
replace HeadWage = . if HeadWage == 9999999 & (year == 1993 | year == 1994 | year == 1997)

replace PrincipalRem = . if (PrincipalRem >= 9999998 & year>=1994)

drop if ID == .

*************************************************
* 2. label variables
*************************************************
label variable ID "ID1968"
label variable IW "Interview Number of that year"
label variable year "Interview Year"
label variable HeadTotalWage "Head Total Wage"
label variable WifeTotalWage "Wife Total Wage, corrects for excluding business etc"
label variable Transfer "Bequest, some years total private transfers"

sort ID year

label variable RelativeHeadReportUnit "Relative help to head time unit"
label variable HeadWageHour "PSID head hourly wage"
label variable WifeWageHour "PSID wife hourly wage"
label variable HeadWage_gen "Own calculation head hourly wage"
label variable WifeWage_gen "Own calculation wife hourly wage"
label variable SexHead "Male = 1"
label variable identifier "1000*ID68 + Person number 68"
label variable Inheritance "Inheritance available after 1988"
label variable HeadWage "not used, PSID Family data"
label variable HeadHours "Head total hours worked"
label variable WifeHours "Wife total hours worked"

*************************************************
* 3. this file is grouped by ID1968, not so informative
save Data_panel_ID.dta
*************************************************
* only keep head and wife
drop if Head == .
keep if Head == 1

bys year: egen NumHHYear = count(_n)
label variable NumHHYear "Number of HH per year"
sort identifier year

order identifier, first
*bys ID: gen bequest_indicator = 1 if Transfer >0 & Head == 1
bys identifier: gen bequest_indicator = 1 if Transfer >0 & Head == 1
replace bequest_indicator = 0 if bequest_indicator == . & Head == 1
* splited families under the same ID may have different bequests
bys identifier: gen bequest_cum = sum(bequest_indicator)

gen bequest_first = Transfer if bequest_cum == 1
gen bequest_second = Transfer if bequest_cum == 2

bys identifier : egen bequest_1st = max(bequest_first) 
bys identifier : egen bequest_2nd = max(bequest_second) 

gen bequest_first_year = year if bequest_cum == 1
gen bequest_second_year = year if bequest_cum == 2

bys identifier: egen bequest_1st_year = min(bequest_first_year)
bys identifier: egen bequest_2nd_year = min(bequest_second_year)

drop bequest_first_year bequest_second_year bequest_first bequest_second
label variable bequest_1st "The first bequest $"
label variable bequest_2nd "The second bequest $"
label variable bequest_1st_year "The first bequest year"
label variable bequest_2nd_year "The second bequest year"

* SRC sample
keep if ID<= 3000
drop _merge

*************************************************
* 4. this file is grouped by head identifier
save Data_panel_family.dta
*************************************************
gen check_head = HeadWage_gen - HeadWageHour
sum check_head
gen check_wife = WifeWage_gen - WifeWageHour
sum check_wife
list HeadWage_gen if check_head > 100 & check_head ~=.
 
*************************************************
*************************************************
